'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _fp = require('lodash/fp');

var _assertQueue = require('./assert-queue');

var _assertQueue2 = _interopRequireDefault(_assertQueue);

var _workerConsumerFactory = require('./worker-consumer-factory');

var _workerConsumerFactory2 = _interopRequireDefault(_workerConsumerFactory);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const defaultWorkerOptions = {
  noAck: false
};

const addWorker = (() => {
  var _ref = (0, _asyncToGenerator3.default)(function* (args, plugin) {
    const worker = args.worker,
          options = args.options;

    var _ref2 = options || {};

    const workerOptions = _ref2.workerOptions;


    try {
      var _ref3 = yield (0, _assertQueue2.default)(args, plugin);

      const channel = _ref3.channel,
            queue = _ref3.queue,
            assertedQueue = (0, _objectWithoutProperties3.default)(_ref3, ['channel', 'queue']);


      const consumer = (0, _workerConsumerFactory2.default)((0, _extends3.default)({}, assertedQueue, {
        channel,
        queue,
        worker
      }));

      const consumerOptions = (0, _fp.defaultsDeep)(defaultWorkerOptions, workerOptions);
      const consumed = channel.consume(queue.queue, consumer, consumerOptions);

      return {
        channel,
        queue,
        consumed
      };
    } catch (error) {
      throw error;
    }
  });

  return function addWorker(_x, _x2) {
    return _ref.apply(this, arguments);
  };
})();

exports.default = addWorker;